Bug 1305650 - Review Request: uispec4j - Java/Swing GUI testing made simple
Review Request: uispec4j - Java/Swing GUI testing made simple
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: jiri vanek
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-08 15:02 EST by Raphael Groner
Modified: 2016-04-09 10:22 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-04-06 10:08:22 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jvanek: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Raphael Groner 2016-02-08 15:02:15 EST
Spec URL: https://raphgro.fedorapeople.org/review/java/testing/uispec4j.spec
SRPM URL: https://raphgro.fedorapeople.org/review/java/testing/uispec4j-2.5-0.1.20150412gitfdc0b42.fc23.src.rpm
Description: Java/Swing GUI testing made simple
Fedora Account System Username: raphgro
Comment 1 Raphael Groner 2016-02-08 15:05:04 EST
[ERROR] Failed to execute goal on project uispec4j: Could not resolve dependencies for project org.uispec4j:uispec4j:jar:2.5-SNAPSHOT: The following artifacts could not be resolved: asm:asm:jar:3.3.1, asm:asm-util:jar:3.3.1: Cannot access central (https://repo.maven.apache.org/maven2) in offline mode and the artifact asm:asm:jar:3.3.1 has not been downloaded from it before. -> [Help 1]
[ERROR] 
[ERROR] To see the full stack trace of the errors, re-run Maven with the -e switch.
[ERROR] Re-run Maven using the -X switch to enable full debug logging.
[ERROR] 
[ERROR] For more information about the errors and possible solutions, please read the following articles:
[ERROR] [Help 1] http://cwiki.apache.org/confluence/display/MAVEN/DependencyResolutionException

BR: objectweb-asm seems not to be sufficient to resolve this missed dependency. I'll investigate more.
Comment 2 gil cattaneo 2016-02-08 15:13:58 EST
Is sufficient change BuildRequires:  objectweb-asm with BuildRequires:  objectweb-asm3
Comment 3 gil cattaneo 2016-02-08 15:22:49 EST
%pom_change_dep asm: ::3
OR
%pom_change_dep asm: ::3.3.1
Comment 4 gil cattaneo 2016-02-08 16:44:40 EST
e.g.

BuildRequires: maven-local
BuildRequires: mvn(asm:asm)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.codehaus.mojo:build-helper-maven-plugin)
# for tests
BuildRequires: mvn(asm:asm-util)
BuildRequires: mvn(org.testng:testng)
BuildRequires: xorg-x11-server-Xvfb

....

%package examples
Summary:       Examples for %{project}

%description examples
UISpec4J sample applications

%package root
Summary:       UISpec4J ROOT POM

%description root
UISpec4J Parent POM.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{project}-%{commit0}

# Set proper encoding value
%pom_xpath_set pom:encoding UTF-8
# Unsupported configuration
%pom_remove_plugin :maven-surefire-plugin

%pom_remove_plugin -r :maven-javadoc-plugin

# Fix non ASCII chars
for s in %{name}/src/main/java/org/uispec4j/Key.java;do
  native2ascii -encoding UTF8 ${s} ${s}
done

%mvn_package :addressbook examples
%mvn_package :calculator examples

%mvn_package :%{name}::jdk8: %{name}
%mvn_alias :%{name} :%{name}::jdk5: :%{name}::jdk6: :%{name}::jdk7:

%build

# do tests in some fake X
export DISPLAY=:98
Xvfb $DISPLAY &
trap "kill $! || true" EXIT
%mvn_build -s -- -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install

%files -f .mfiles-%{name}
%doc README.md
%license %{name}/LICENSE.txt

%files examples -f .mfiles-examples
%license %{name}/LICENSE.txt

%files root -f .mfiles-%{name}-root
%license %{name}/LICENSE.txt

%files javadoc -f .mfiles-javadoc
%license %{name}/LICENSE.txt
Comment 5 Raphael Groner 2016-02-11 10:54:13 EST
Hi gil,

thanks for your help. I've updated my uploads, links are the same. Now, the examples run into a weird bug in awt (and propably framebuffer of virtual Xorg).
Comment 6 jiri vanek 2016-03-15 08:16:35 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 321 files have unknown license.
     Detailed output of licensecheck in
     /home/jvanek/1305650-uispec4j/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[ ]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     uispec4j-examples , uispec4j-root , uispec4j-javadoc
[?]: Package functions as described.
[-]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.
Comment 7 jiri vanek 2016-03-15 08:17:36 EDT
Issues:
	- the usptream project is very poorely licensed. This should be fixed
	- the package license do not comply with upstream. I found usptream most close to CPL 1.0, but specfile contaiins CDL
	- the changelog is of course correct, but the version looks bad. How is  your checkout related to 2.5-0.1... ?. You can expect next reelase to be 2.5 so yours 2.5-0.1 will not update to 2.5.0 (but of coourse it will to 2.5-1) THis is just something to thinga bout.
		Hard toi say what  to preffere from:
		- https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Pre-Release_packages
		and
		- https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Snapshot_packages
		You seems to be in the middle
	- there are installed /suer/share/java uispec4j-jdk8 and uispec4j jars. They both seems to be nearly same by content, and both are built by jdk8. So I'm wondering if both have sense to pack and install.


Non fatal issues:
	- Latest upstream version is on Nov 26, 2011 2.4. Thtas bad :) Maybe usptream can do just some 3.0.fedora "release" - tag only - so the ID used in spec and in RPM names is better?
	- # Fix non ASCII chars
		this shoould be upstreamed
	- It may be my lack if knowledge, but why the root package? It od not seem to have much sense...
	- I (for now - will retry) failed how to actually test if the package works. So maybe some helpo file can be packed with examples?
Comment 8 jiri vanek 2016-03-15 08:19:32 EDT
One "personal conformort"  asking you for favour -
If you will be fixing the issues above, pelase use another directory in yours 
 https://raphgro.fedorapeople.org/review/java/testing/

something like 
uispec4j/v2/uispec4j.spec
uispec4j/v2/uispec4j-2.5-0.1.20150412gitfdc0b42.fc23.src.rpm

So I can diff the specfiles. This step is no must :)

TY!
Comment 9 Raphael Groner 2016-03-23 12:35:35 EDT
Hi Jiri,
thanks for your review. Is there any blocker for a formal approval, except the (obvious) typo in license?

Spec URL: https://raphgro.fedorapeople.org/review/java/testing/uispec4j.spec
SRPM URL: https://raphgro.fedorapeople.org/review/java/testing/uispec4j-2.5-0.2.20150412gitfdc0b42.fc23.src.rpm

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=13437566

%changelog
* Wed Mar 23 2016 Raphael Groner <projects.rg@smart.ms> - 2.5-0.2.20150412gitfdc0b42
- fix license CPL
- use xvfb-run -a
Comment 10 jiri vanek 2016-03-23 12:40:00 EDT
Dont you consider changing of versioning?
Comment 11 Raphael Groner 2016-03-23 13:08:26 EDT
(In reply to jiri vanek from comment #10)
> Dont you consider changing of versioning?

No. It's obviously a pre-release of 2.5 as noted in the sources. For the alphatag I use the git hash as explained for snapshot packages, we can consider git snapshots as special sort of pre-releases. I've already done so for others of my packages.
https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Pre-Release_packages
https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Snapshot_packages
Comment 12 jiri vanek 2016-03-23 13:44:42 EDT
And is there osme way how to verify that the package works?

They had demos inside, but I was unable to run them.
Comment 13 Raphael Groner 2016-03-23 15:37:21 EDT
(In reply to jiri vanek from comment #12)
> And is there osme way how to verify that the package works?
> 
> They had demos inside, but I was unable to run them.

https://uispec4j.github.io/UISpec4J/reports/apidocs/
https://github.com/UISpec4J/UISpec4J/issues/25

RTFM, honestly. The javadoc is also included as a subpackage. When you have issues with the code, please report them to upstream. That's offtopic for the review.
Comment 14 jiri vanek 2016-03-23 17:25:01 EDT
(In reply to Raphael Groner from comment #13)
> (In reply to jiri vanek from comment #12)
> > And is there osme way how to verify that the package works?
> > 
> > They had demos inside, but I was unable to run them.
> 
> https://uispec4j.github.io/UISpec4J/reports/apidocs/
> https://github.com/UISpec4J/UISpec4J/issues/25
> 
> RTFM, honestly. The javadoc is also included as a subpackage. When you have
> issues with the code, please report them to upstream. That's offtopic for
> the review.

I dont have issue with code. I dont have issues to read docs not javadoc. But there are demos included in this package, and I was unable to use them. 

Are you able to run the demos?
Comment 15 Raphael Groner 2016-03-23 18:53:16 EDT
(In reply to jiri vanek from comment #14)
…
> Are you able to run the demos?

Running samples.addressbook.model.AddressBookTest
Tests run: 12, Failures: 0, Errors: 0, Skipped: 0, Time elapsed: 2.156 sec - in samples.addressbook.model.AddressBookTest

Running samples.calculator.CalculatorTest
Tests run: 23, Failures: 0, Errors: 0, Skipped: 0, Time elapsed: 3.713 sec - in samples.calculator.CalculatorTest

(from build.log)
Comment 16 Raphael Groner 2016-03-23 19:17:17 EDT
(In reply to jiri vanek from comment #14)
…
> Are you able to run the demos?

Please also notice in %prep

# FIXME sloppy tests with a bug in awt
rm addressbook/src/test/java/samples/addressbook/functests/*Test.java
rm calculator/src/test/java/samples/calculator/functests/CalculatorStage*Test.java
Comment 17 jiri vanek 2016-03-24 04:47:35 EDT
(In reply to Raphael Groner from comment #15)
> (In reply to jiri vanek from comment #14)
> …
> > Are you able to run the demos?
> 
> Running samples.addressbook.model.AddressBookTest
> Tests run: 12, Failures: 0, Errors: 0, Skipped: 0, Time elapsed: 2.156 sec -
> in samples.addressbook.model.AddressBookTest
> 
> Running samples.calculator.CalculatorTest
> Tests run: 23, Failures: 0, Errors: 0, Skipped: 0, Time elapsed: 3.713 sec -
> in samples.calculator.CalculatorTest
> 
> (from build.log)

Ok. I overlooked that.  sorry.
I still think that the this package need versioning and licensing pressure to upstream.

> RTFM, honestly.

Although I agree that my issues except (*not* obvious) typo in license, were more related to usptream then to package itself, responsibility of each review is to ensure that no garbage goes to fedora. Considering that after review, it moreover one man show with a lot of freedom, then after the review the package more degrade then anything else.

Anyway package is APPROVED
Comment 18 Raphael Groner 2016-03-24 07:51:45 EDT
Thanks for the review! I'll do a revenge in bug #1312015.
Comment 19 Gwyn Ciesla 2016-03-24 18:33:34 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/uispec4j
Comment 20 Raphael Groner 2016-03-30 16:55:35 EDT
(In reply to jiri vanek from comment #14)
…
> Are you able to run the demos?

See also
http://users.csc.calpoly.edu/~jdalbey/309/Lectures/UISpec4J-NB-example.html
http://users.csc.calpoly.edu/~jdalbey/309/Assign/UISpec4JTraining.pdf
https://www.snip2code.com/Snippet/91888/Example-of-how-test-window-closing-logic

In the hope that helps and makes the purpose somehow clearer to understand.
Comment 21 jiri vanek 2016-03-31 04:40:41 EDT
Those are worthy links. Thank you for inclusion.
Comment 22 Fedora Update System 2016-03-31 07:34:07 EDT
uispec4j-2.5-0.2.20150412gitfdc0b42.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-c44e5407a7
Comment 23 Fedora Update System 2016-03-31 07:34:12 EDT
uispec4j-2.5-0.2.20150412gitfdc0b42.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-e2e4c0ac0c
Comment 24 Fedora Update System 2016-04-01 11:24:03 EDT
uispec4j-2.5-0.2.20150412gitfdc0b42.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-c44e5407a7
Comment 25 Fedora Update System 2016-04-01 16:55:14 EDT
uispec4j-2.5-0.2.20150412gitfdc0b42.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-e2e4c0ac0c
Comment 26 Fedora Update System 2016-04-06 10:08:20 EDT
uispec4j-2.5-0.2.20150412gitfdc0b42.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 27 Fedora Update System 2016-04-09 10:22:15 EDT
uispec4j-2.5-0.2.20150412gitfdc0b42.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.